include Handshake.inc
;*****************CODE SEGMENT **********************************
.code 
start:;START PROC HERE 
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		invoke CreateEvent,NULL, FALSE, FALSE, NULL
		mov g_hevtRequestSubmitted,eax
		invoke CreateEvent,NULL, FALSE, FALSE, NULL
		mov g_hevtResultReturned,eax
		;Spawn the server thread
		invoke CreateThread,NULL, 0,addr ServerThread, NULL, 0, addr dwThreadID
		mov hThreadServer,eax
		invoke	InitCommonControls
		;Execute the client thread's user-interface
		invoke	DialogBoxParam,hInstance,IDD_HANDSHAKE,NULL,offset DlgProc,0
		;The client's UI is closing, have the server thread shutdown
		invoke lstrcpy,addr g_szSharedRequestAndResultBuffer, addr g_szServerShutdown
		invoke SetEvent,g_hevtRequestSubmitted
		;Wait for the server thread to acknowledge the shutdown AND
        ;wait for the server thread to fully terminate
		mov eax,g_hevtResultReturned
		mov h[1],eax
		mov eax,hThreadServer
		mov h[2],eax
		invoke WaitForMultipleObjects,2, addr h, TRUE, INFINITE
		invoke CloseHandle,hThreadServer
	    invoke CloseHandle,g_hevtRequestSubmitted      
	    invoke CloseHandle,g_hevtResultReturned   
		invoke	ExitProcess,NULL

;**************Server Thread PROC ******************************
ServerThread  proc pvParam:dword
local fShutdown:dword
	;Assume that the server thread is to run forever
	mov fShutdown,0
	.while !fShutdown
		;Wait for the client to submit a request
		invoke WaitForSingleObject,g_hevtRequestSubmitted, INFINITE
		;Check to see if the client wants the server to terminate
		invoke lstrcmpi,addr g_szSharedRequestAndResultBuffer, addr g_szServerShutdown
		.if eax==0
			mov fShutdown,1
		.else
		.endif
		.if eax!=0
			;Process the client's request (reverse the string)
			invoke _strrev,addr g_szSharedRequestAndResultBuffer
			;invoke revstr,addr g_szSharedRequestAndResultBuffer,addr g_szTempBuffer
			;invoke lstrcpy,addr g_szSharedRequestAndResultBuffer,addr g_szTempBuffer
		.else
		.endif
		;Let the client process the request's result
		invoke SetEvent,g_hevtResultReturned
	.endw
	xor eax,eax
    ret
ServerThread endp

;*************DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			invoke LoadIcon,hInstance,IDI_HANDSHAKE
			push eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax		
			pop eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
			;Initialize the edit control with some test data request
			dsText InitText,"Some test data"
			invoke SetDlgItemText,hWnd,IDC_REQUEST,addr InitText
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			.if eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			.elseif eax==IDC_SUBMIT
				;Submit a request to the server thread
				;Copy the request string into the shared data buffer
				invoke GetDlgItemText,hWnd,IDC_REQUEST,addr g_szSharedRequestAndResultBuffer,sizeof g_szSharedRequestAndResultBuffer
				;Let the server thread know that a request is ready in the buffer
				invoke SetEvent,g_hevtRequestSubmitted
				;Wait for the server to process the request and give us the result
				invoke WaitForSingleObject,g_hevtResultReturned, INFINITE
				;Let the user know the result
				invoke SetDlgItemText,hWnd,IDC_RESULT,addr g_szSharedRequestAndResultBuffer
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************


end	start
